package methodtest;

import java.util.*;

class Customer {
    protected String _name;
    private Vector _rentals = new Vector();
    
    protected Customer() {
    }

    public Customer(String name) {
        _name = name;
    }

    public void addRental(Rental arg) {
        _rentals.add(arg);
    }

    public String getName() {
        return _name;
    }

    public String statement() {
        double totalAmount = 0;
        int frequentRenterPoints = 0;
        Iterator rentals = _rentals.iterator();
        String result = "Rental Record for " + getName() + "\n";
        
        while (rentals.hasNext()) {
            double thisAmount = 0;
            Rental each = (Rental)rentals.next();

            thisAmount = amountFor(each);

            frequentRenterPoints++;

            if ((each.getMovie().getPriceCode() == Movie.NEW_RELEASE) &&
                each.getDaysRented() > 1)
                frequentRenterPoints++;

            result += "\t" + each.getMovie().getTitle() + "\t" +
                String.valueOf(thisAmount) + "\n";
            totalAmount += thisAmount;
        }

        result += "Amount owed is " + String.valueOf(totalAmount) + "\n";
        result += "You earned " + String.valueOf(frequentRenterPoints) +
            " frequent renter points";
        return result;
    }

    public double amountFor(Rental aRental) {
        double result = 0;
        switch (aRental.getMovie().getPriceCode()) {
            case Movie.REGULAR:
                result += 2;
                if (aRental.getDaysRented() > 2)
                    result += (aRental.getDaysRented() - 2) * 1.5;
                break;
            case Movie.NEW_RELEASE:
                result += aRental.getDaysRented() * 3;
                break;
            case Movie.CHILDRENS:
                result += 1.5;
                if (aRental.getDaysRented() > 3)
                    result += (aRental.getDaysRented() - 3 ) * 1.5;
                break;
        }
        return result;
    }

    protected Address address;

    public String getAddress() {
        return address.getZipCode() + " " + address.getCountry();
    }

    public String getAddress2() {
        return address.getZipCode() + " " + address.getCountry();
    }
}

class Customer2 extends Customer {
    private String _name;
}

class Customer3 extends Customer2 {

    public String getName() {
        return "**" + getName() + getAddress();
    }
}
